const fs = require("fs");
const pbsc=require("nv-path-basic");
const path = require("path");
const {tree,unparse} = require("nv-js-parse");

const {rfile,rwalk} = require("nv-file-reader");
const agen_dig_softlink = rwalk.agen_dig_softlink;

const DFLT_SUFFIXES = ['js','ts','json']


async function * agen_paths(p,suffixes=DFLT_SUFFIXES) {
    let ag = agen_dig_softlink(p,false);
    for await(let each of ag) {
        if(each.type ==='file') {
            let d = path.parse(each.path);
            if(suffixes.includes(d.ext.slice(1))) {
                yield(each.path)
            }    else {
            }
        }
    }
}

async function * agen_strlits(
      ST,PAS,TBL,P,
      max_size =10000,
      suffixes=DFLT_SUFFIXES
) {
    let ag = agen_paths(P,suffixes)
    for await(let p of ag) {
        let file_dict = {}
        PAS[p] = file_dict;
        let code = await rfile.rstr(p);
        try {
            let t ;
            if(path.parse(p).ext === '.json') {
                code = `____=${code}`;
                t = tree(code,{max_size});
                t = t.$sdfs()[4];
            } else {
                t = tree(code,{max_size});
            }
            let lits  = t.StringLiteral();
            for(let nd of lits) {
                 let ast_path = nd.get_ast_abs_pl().join("/") 
                 let s = nd.ast.value;
                 file_dict[ast_path] = nd.ast.value;
                 ST.add(s);
                 TBL.push([p,ast_path,s])     
            }
        } catch(err) {
        }
    }
}


async function find(P="../lib",max_size=20000,suffixes=DFLT_SUFFIXES) {
   let ST = new Set();
   let PAS = {}
   let TBL = []
   var ag = agen_strlits(ST,PAS,TBL,P,max_size,suffixes);
   for await(let p of ag){}
   fs.writeFileSync("str.tbl.json",JSON.stringify(TBL,null,2));
   fs.writeFileSync("str.pas.json",JSON.stringify(PAS,null,2));
   ////-----------
   let A = Array.from(ST);
   A.sort();
   fs.writeFileSync("str.brief.json",JSON.stringify(A,null,2));
   ////-----------------
   return({ST,PAS,TBL})
}

module.exports = find;
